﻿#Region "-- Imports --"
Imports Infragistics.Win.UltraWinListView
Imports Infragistics.Win.UltraWinSchedule
Imports Infragistics.Win

#End Region

Public Class frmMain

#Region "-- Constants --"
  'Insert code here
#End Region

#Region "-- Enumerations --"
  Public Enum Employee As Short
    BarneyR
    FredF
    SylvesterS
  End Enum
  Public Enum LogListViewColumn As Short
    Time
    Control
    EventName
  End Enum
#End Region

#Region "-- Local Variables --"
  Private _TargetDate As DateTime = CDate("21 Dec 2012")
#End Region

#Region "-- Property Storage --"
  'Insert code here
#End Region

#Region "-- Properties --"
  'Insert code here
#End Region

#Region "-- Events --"
  'Insert code here
#End Region

#Region "-- Structors --"
  'Insert code here
#End Region

#Region "-- Event Handlers --"
#Region "  -- Form Events --"
  Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
    Try
      Debug.WriteLine("")
      Debug.WriteLine("")
      Debug.WriteLine("")
      SetUpCalendar()
      CreateAppointments()
      ulvwEvents.ViewSettingsDetails.ImageSize = Size.Empty
    Catch ex As Exception
      MessageBox.Show(ExceptionMessage(ex), "Form Load Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Try
  End Sub
#End Region
#Region "  -- UltraDayView Events --"
  Private Sub DayView1_AfterAppointmentsMoved(sender As Object, e As Infragistics.Win.UltraWinSchedule.AfterAppointmentsMovedEventArgs) Handles DayView1.AfterAppointmentsMoved
    LogEvent(DayView1, "AfterAppointmentsMoved")
  End Sub
  Private Sub DayView1_AppointmentResized(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentResizedEventArgs) Handles DayView1.AppointmentResized
    LogEvent(DayView1, "AppointmentResized")
  End Sub
  Private Sub DayView1_AppointmentResizing(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentResizingEventArgs) Handles DayView1.AppointmentResizing
    LogEvent(DayView1, "AppointmentResizing")
  End Sub
  Private Sub DayView1_AppointmentsDragComplete(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragCompleteEventArgs) Handles DayView1.AppointmentsDragComplete
    LogEvent(DayView1, String.Format("AppointmentsDragComplete : {0}", UltraCalendarInfo1.SelectedAppointments.Count))
  End Sub
  Private Sub DayView1_AppointmentsDragDrop(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragDropEventArgs) Handles DayView1.AppointmentsDragDrop
    LogEvent(DayView1, String.Format("AppointmentsDragDrop : {0}", e.Appointments.Count))
  End Sub
  Private Sub DayView1_AppointmentsDragging(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDraggingEventArgs) Handles DayView1.AppointmentsDragging
    e.AllowCopy = False
  End Sub
  Private Sub DayView1_BeforeAppointmentEdited(sender As Object, e As Infragistics.Win.UltraWinSchedule.CancelableAppointmentEventArgs) Handles DayView1.BeforeAppointmentEdited
    e.Cancel = True 'Do not allow direct editing of text  
  End Sub
  Private Sub DayView1_MouseDown(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles DayView1.MouseDown
    Dim element As Infragistics.Win.UIElement = DayView1.UIElement.ElementFromPoint(e.Location)

    Dim debugLevel As Short = 0
    If debugLevel > 0 Then Debug.WriteLine(String.Format("{0}.calDay.MouseDown : element.GetType = '{1}'", Me.GetType.FullName, element.GetType.FullName))

    If element IsNot Nothing AndAlso (TypeOf element Is DayView.AppointmentUIElement OrElse element.GetAncestor(GetType(DayView.AppointmentUIElement)) IsNot Nothing) Then
      Dim apptUIElement As DayView.AppointmentUIElement = CType(element.GetAncestor(GetType(DayView.AppointmentUIElement)), DayView.AppointmentUIElement)
      If TypeOf apptUIElement.SelectableItem Is Infragistics.Win.UltraWinSchedule.Appointment Then
        Dim ultraAppt As Infragistics.Win.UltraWinSchedule.Appointment = apptUIElement.SelectableItem
        PropertyGrid1.SelectedObject = ultraAppt
        txtType.Text = ultraAppt.GetType.Name
      End If
    ElseIf element IsNot Nothing AndAlso (TypeOf element Is DayView.AllDayEventUIElement OrElse element.GetAncestor(GetType(DayView.AllDayEventUIElement)) IsNot Nothing) Then
      Dim apptUIElement As DayView.AllDayEventUIElement = CType(element.GetAncestor(GetType(DayView.AllDayEventUIElement)), DayView.AllDayEventUIElement)
      If TypeOf apptUIElement.SelectableItem Is Infragistics.Win.UltraWinSchedule.Appointment Then
        Dim ultraAppt As Infragistics.Win.UltraWinSchedule.Appointment = apptUIElement.SelectableItem
        PropertyGrid1.SelectedObject = ultraAppt
        txtType.Text = ultraAppt.GetType.Name
      End If
    End If
  End Sub
#End Region
#Region "  -- UltraWeekView Events --"
  Private Sub WeekView1_AppointmentsDragDrop(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragDropEventArgs) Handles WeekView1.AppointmentsDragDrop
    LogEvent(WeekView1, String.Format("AppointmentsDragDrop : {0}", e.Appointments.Count))
  End Sub
  Private Sub WeekView1_BeforeAppointmentEdit(sender As Object, e As Infragistics.Win.UltraWinSchedule.BeforeAppointmentEditEventArgs) Handles WeekView1.BeforeAppointmentEdit
    e.Cancel = True
  End Sub
  Private Sub WeekView1_MouseDoubleClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles WeekView1.MouseDoubleClick
    Dim ultraAppt As Infragistics.Win.UltraWinSchedule.Appointment = WeekView1.GetAppointmentFromPoint(e.Location)
    If ultraAppt Is Nothing Then
      Dim clickedElement As Infragistics.Win.UIElement = Nothing
      For Each element As UIElement In WeekView1.UIElement.ChildElements
        If element.Rect.Contains(e.Location) Then
          clickedElement = element
          Exit For
        End If
      Next
      If TypeOf clickedElement Is WeekView.WeekAreaUIElement Then
        If UltraCalendarInfo1.SelectedDateRanges.Count > 0 Then
          Dim dateRange As Infragistics.Win.UltraWinSchedule.DateRange = Me.UltraCalendarInfo1.SelectedDateRanges.Item(0)
          rbnViewDay.Checked = True
        End If
      End If
    End If
  End Sub
#End Region
#Region "  -- UltraMonthViewSingle Events --"
  Private Sub MonthView1_AppointmentsDragDrop(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragDropEventArgs) Handles MonthView1.AppointmentsDragDrop
    LogEvent(MonthView1, String.Format("AppointmentsDragDrop : {0}", e.Appointments.Count))
  End Sub
  Private Sub MonthView1_MouseDoubleClick(sender As Object, e As System.Windows.Forms.MouseEventArgs) Handles MonthView1.MouseDoubleClick
    Dim clickedElement As UIElement = Nothing
    For Each element As UIElement In MonthView1.UIElement.ChildElements
      If element.Rect.Contains(e.Location) Then
        clickedElement = element
        Exit For
      End If
    Next
    If TypeOf clickedElement Is MonthViewSingle.MonthAreaUIElement Then
      Dim ultraAppt As Infragistics.Win.UltraWinSchedule.Appointment = MonthView1.GetAppointmentFromPoint(e.Location)
      If ultraAppt Is Nothing Then
        If UltraCalendarInfo1.SelectedDateRanges.Count > 0 Then
          Dim dateRange As Infragistics.Win.UltraWinSchedule.DateRange = Me.UltraCalendarInfo1.SelectedDateRanges.Item(0)
          rbnViewDay.Checked = True
        End If
      End If
    ElseIf TypeOf clickedElement Is MonthViewSingle.PreWeekAreaUIElement Then
      Dim weekAreaUIElement As MonthViewSingle.PreWeekAreaUIElement = CType(clickedElement, MonthViewSingle.PreWeekAreaUIElement)
      For Each element As UIElement In weekAreaUIElement.ChildElements
        If element.Rect.Contains(e.Location) Then
          Dim weekNumUIElement As MonthViewSingle.WeekNumberUIElement = CType(element, MonthViewSingle.WeekNumberUIElement)
          Dim obj As Object = weekNumUIElement.SelectableItem
          If weekNumUIElement.SelectableItem IsNot Nothing AndAlso TypeOf weekNumUIElement.SelectableItem Is UltraWinSchedule.Week Then
            Dim week As UltraWinSchedule.Week = CType(weekNumUIElement.SelectableItem, UltraWinSchedule.Week)
            rbnViewWeek.Checked = True
          End If
          Exit For
        End If
      Next
    End If
  End Sub
#End Region
#Region "  -- UltraTimeline Events --"
  'Private Sub TimelineView1_AfterAppointmentsMoved(sender As Object, e As Infragistics.Win.UltraWinSchedule.AfterAppointmentsMovedEventArgs) Handles TimelineView1.AfterAppointmentsMoved
  '  LogEvent(TimelineView1, "AfterAppointmentsMoved") - THIS EVENT DOES NOT EXIST
  'End Sub
  Private Sub TimelineView1_AppointmentResized(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentResizedEventArgs) Handles TimelineView1.AppointmentResized
    LogEvent(TimelineView1, "AppointmentResized")
  End Sub
  Private Sub TimelineView1_AppointmentResizing(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentResizingEventArgs) Handles TimelineView1.AppointmentResizing
    LogEvent(TimelineView1, "AppointmentResizing")
  End Sub
  'Private Sub TimelineView1_AppointmentsDragComplete(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragCompleteEventArgs) Handles TimelineView1.AppointmentsDragComplete
  '  LogEvent(TimelineView1, "AppointmentsDragComplete") - THIS EVENT DOES NOT EXIST
  'End Sub
  Private Sub TimelineView1_AppointmentsDragDrop(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDragDropEventArgs) Handles TimelineView1.AppointmentsDragDrop
    LogEvent(TimelineView1, String.Format("AppointmentsDragDrop : {0}", e.Appointments.Count))
  End Sub
  Private Sub TimelineView1_AppointmentsDragging(sender As Object, e As Infragistics.Win.UltraWinSchedule.AppointmentsDraggingEventArgs) Handles TimelineView1.AppointmentsDragging
    e.AllowCopy = False
  End Sub
#End Region
#Region "  -- Other Events --"
  Private Sub rbnViewDay_CheckedChanged(sender As Object, e As System.EventArgs) Handles rbnViewDay.CheckedChanged, rbnViewWeek.CheckedChanged, rbnViewMonth.CheckedChanged, rbnViewTimeline.CheckedChanged
    DayView1.Visible = (sender Is rbnViewDay AndAlso rbnViewDay.Checked)
    WeekView1.Visible = (sender Is rbnViewWeek AndAlso rbnViewWeek.Checked)
    MonthView1.Visible = (sender Is rbnViewMonth AndAlso rbnViewMonth.Checked)
    TimelineView1.Visible = (sender Is rbnViewTimeline AndAlso rbnViewTimeline.Checked)
  End Sub
  Private Sub mnuClearEventList_Click(sender As System.Object, e As System.EventArgs) Handles mnuClearEventList.Click
    ulvwEvents.Items.Clear()
  End Sub
#End Region
#End Region

#Region "-- Methods --"
  'Insert code here
#End Region

#Region "-- Private Subs --"
  Private Sub CreateAppointments()
    Try
      CreateAppointment(_TargetDate.AtTime("8 am"), _TargetDate.AtTime("9 am"), "Take Bam-Bam to School", Employee.BarneyR)
      CreateAppointment(_TargetDate.AtTime("9 am"), _TargetDate.AtTime("5 pm"), "Crush Rocks at the Quarry", Employee.BarneyR)
      CreateAppointment(_TargetDate.AtTime("7 pm"), _TargetDate.AtTime("10 pm"), "Loyal Order of Water Buffaloes Lodge No. 26", Employee.BarneyR)
      CreateAppointment(_TargetDate.AtTime("7 pm"), _TargetDate.AddDays(2).AtTime("10 am"), "Lodge Tour", Employee.BarneyR)

      CreateAppointment(_TargetDate.AtTime("6 am"), _TargetDate.AtTime("7 am"), "Take Dino for Walk", Employee.FredF)
      CreateAppointment(_TargetDate.AtTime("7 am"), _TargetDate.AtTime("8 am"), "Eat Breakfast", Employee.FredF)
      CreateAppointment(_TargetDate.AtTime("9 am"), _TargetDate.AtTime("5 pm"), "Mine Rocks at the Quarry", Employee.FredF)
      CreateAppointment(_TargetDate.AtTime("6 pm"), _TargetDate.AtTime("7 pm"), "Pick up Ol' Barney Boy", Employee.FredF)
      CreateAppointment(_TargetDate.AtTime("7 pm"), _TargetDate.AtTime("10 pm"), "Loyal Order of Water Buffaloes Lodge No. 26", Employee.FredF)

      CreateAppointment(_TargetDate.AtTime("8 am"), _TargetDate.AtTime("9 am"), "Drive to Work", Employee.SylvesterS)
      CreateAppointment(_TargetDate.AtTime("9 am"), _TargetDate.AtTime("5 pm"), "Yell at Flintstone", Employee.SylvesterS)
      CreateAppointment(_TargetDate.AtTime("5 pm"), _TargetDate.AtTime("6 pm"), "Drive Home", Employee.SylvesterS)

    Catch ex As Exception
      Throw New Exception(String.Format("{0}.CreateAppointments Error", Me.GetType.Name), ex)
    End Try
  End Sub
  Private Sub CreateAppointment(startDate As DateTime, endDate As DateTime, subject As String, ownerKey As Employee)
    Try
      Dim calAppt As New Infragistics.Win.UltraWinSchedule.Appointment(startDate, endDate)
      calAppt.Subject = subject
      calAppt.Description = String.Empty
      If Me.UltraCalendarInfo1.Owners.Exists(ownerKey.ToString) Then
        calAppt.Owner = Me.UltraCalendarInfo1.Owners(ownerKey.ToString)
      End If
      UltraCalendarInfo1.Appointments.Add(calAppt)
      'calAppt.Locked = apptUI.Schedule.Anchored
      'calAppt.Appearance.Image = General.Utilities.GetAppointmentImage(apptUI.Resource, apptUI.Schedule, True)
      'calAppt.AllDayEvent = apptUI.Schedule.Duration.SpannedDays > 1
      'calAppt.Tag = apptUI
    Catch ex As Exception
      Throw New Exception(String.Format("{0}.CreateAppointments Error", Me.GetType.Name), ex)
    End Try
  End Sub
  Private Function ExceptionMessage(ByVal ex As Exception, Optional subMsgIndent As Short = 0, Optional showBullet As Boolean = True) As String
    Dim sb As New System.Text.StringBuilder
    Try
      If ex Is Nothing Then Throw New ArgumentNullException("Exception cannot be null ( Nothing in Visual Basic )")
      If subMsgIndent < 0 Then subMsgIndent = 0
      If subMsgIndent > 0 Then sb.AppendLine("")
      sb.AppendLine(String.Format("{0}{1}{2}", Space(subMsgIndent), IIf(showBullet, "=> ", ""), ex.Message))
      While ex.InnerException IsNot Nothing
        ex = ex.InnerException
        sb.AppendLine(String.Format("{0}{1}{2}", Space(subMsgIndent), IIf(showBullet, "=> ", ""), ex.Message))
      End While
    Catch ex1 As Exception
      MessageBox.Show(ex1.Message, "ExceptionMessage Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
    End Try
    Return sb.ToString
  End Function
  Public Sub LogEvent(ctrl As Control, eventName As String)
    Try
      Dim item As New UltraListViewItem
      item.Value = Now.ToString("HH:mm:ss.fff")
      Me.ulvwEvents.Items.Add(item)
      item.SubItems.Item(LogListViewColumn.Control.ToString).Value = ctrl.Name
      item.SubItems.Item(LogListViewColumn.EventName.ToString).Value = eventName
      item.BringIntoView()
      Me.ulvwEvents.SelectedItems.Add(item, True)
    Catch ex As Exception
      Throw New Exception(String.Format("{0}.LogEvent Error", Me.GetType.Name), ex)
    End Try
  End Sub
  Private Sub SetUpCalendar()
    Try
      Me.UltraCalendarInfo1.Owners.UnassignedOwner.Visible = False
      Me.UltraCalendarInfo1.Owners.Add(Employee.BarneyR.ToString, "Barney Rubble")
      Me.UltraCalendarInfo1.Owners.Add(Employee.FredF.ToString, "Fred Flintstone")
      Me.UltraCalendarInfo1.Owners.Add(Employee.SylvesterS.ToString, "Sylvester Slate")
      'Me.DayView1.GroupingStyle = Infragistics.Win.UltraWinSchedule.DayViewGroupingStyle.OwnerWithinDate
      'Me.DayView1.TimeSlotInterval = Infragistics.Win.UltraWinSchedule.TimeSlotInterval.SixtyMinutes
      Me.UltraCalendarInfo1.ActivateDay(_TargetDate)
      Dim slot As TimeSlot = DayView1.GetTimeSlotFromTime(_TargetDate.AtTime("8 am"))
      If slot IsNot Nothing Then
        DayView1.FirstVisibleTimeSlot = slot
      End If
      DayView1.ShowClickToAddIndicator = Infragistics.Win.DefaultableBoolean.False

      DayView1.Dock = DockStyle.Fill
      WeekView1.Dock = DockStyle.Fill
      MonthView1.Dock = DockStyle.Fill
      TimelineView1.Dock = DockStyle.Fill

      rbnViewDay.Checked = True
    Catch ex As Exception
      Throw New Exception(String.Format("{0}.SetUpCalendar Error", Me.GetType.Name), ex)
    End Try
  End Sub
#End Region

End Class
